public static Complex[] TimeDecimationFFT(Complex[] a, int dir)
{
	//1.
	int N = a.Length;
	if (N == 1) return a;
	//2.
	Complex[] a1 = new Complex[N / 2 + N % 2]; //Четные
	Complex[] a2 = new Complex[N / 2]; //Нечетные
	for (int i = 0; i < a.Length; i++)
	{
		if (i % 2 == 0) a1[i / 2] = a[i];
		else a2[i / 2] = a[i];
	}
	//3.
	Complex[] b1 = TimeDecimationFFT(a1, a1.Length, dir); //четные
	Complex[] b2 = TimeDecimationFFT(a2, a2.Length, dir); //нечетные
	//4.
	Complex wN = new Complex(Math.Cos(2 * Math.PI / N), dir * Math.Sin(2 * Math.PI / N));
	Complex w = new Complex(1, 0);
	Complex[] y = new Complex[N];

	for (int j = 0; j < N / 2; j++)
	{
		y[j] = b1[j] + b2[j] * w;
		y[j + N / 2] = b1[j] - b2[j] * w;
		w = w * wN;
	}
	//5.
	return y;
}