﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Numerics;
using ZedGraph;

namespace lab3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        private double Function(double x)
        {
            return Math.Sin(5 * x) + Math.Cos(x);
        }

        private double Function2(double x)
        {
            return Math.Sin(x) + Math.Cos(x);
        }



        private void DrawRealValuesFromComplex(Complex[] funcValues, ZedGraphControl zedGraphControl, string title, Color color)
        {
            // Получим панель для рисования
            GraphPane pane = zedGraphControl.GraphPane;

            pane.XAxis.Title.Text = "N, номер отсчёта";
            pane.YAxis.Title.Text = "Значение функции";
            pane.Title.Text = title;

            // Очистим список кривых на тот случай, если до этого сигналы уже были нарисованы
            pane.CurveList.Clear();

            // Создадим список точек
            PointPairList list = new PointPairList();

            // Заполняем список точек
            for (int i = 0; i < funcValues.Length;  i++)
            {
                // добавим в список точку
                list.Add(i, funcValues[i].Real);
            }

            LineItem myCurve = pane.AddCurve("", list, color, SymbolType.None);

            zedGraphControl.AxisChange();

            // Обновляем график
            zedGraphControl.Invalidate();
        }

        private void DrawRealValues(double[] funcValues, ZedGraphControl zedGraphControl, string title, Color color)
        {
            // Получим панель для рисования
            GraphPane pane = zedGraphControl.GraphPane;

            pane.XAxis.Title.Text = "N, номер отсчёта";
            pane.YAxis.Title.Text = "Значение функции";
            pane.Title.Text = title;

            // Очистим список кривых на тот случай, если до этого сигналы уже были нарисованы
            pane.CurveList.Clear();

            // Создадим список точек
            PointPairList list = new PointPairList();

            // Заполняем список точек
            for (int i = 0; i < funcValues.Length; i++)
            {
                // добавим в список точку
                list.Add(i, funcValues[i]);
            }

            LineItem myCurve = pane.AddCurve("", list, color, SymbolType.Circle);
            myCurve.Symbol.Fill = new Fill(color);
            myCurve.Symbol.Size = 4.5f;

            zedGraphControl.AxisChange();

            // Обновляем график
            zedGraphControl.Invalidate();
        }


        private void drawButton_Click(object sender, EventArgs e)
        {
            int N = int.Parse(textBox_N.Text);
            double log = Math.Log(N, 2);
            if (log - Math.Truncate(log) != 0)
            {
                MessageBox.Show("N должно быть степенью двойки!");
                return;
            }

            double period = 2 * Math.PI;
            
            double[] valuesVector = FunctionValuesVectors.GetRealFunctionValuesVector(Function, period, N);
            DrawRealValues(valuesVector, original_graph, "y = sin(5x) + cos(x)", Color.Blue);

            valuesVector = Walsh.FastWalshTransform(valuesVector, 1);
            DrawRealValues(valuesVector, walsh_graph, "Быстрое преобразование Уолша-Адамара", Color.Red);

            valuesVector = Walsh.FastWalshTransform(valuesVector, -1);
            DrawRealValues(valuesVector, reverseWalsh_graph, "Обратное преобразование Уолша-Адамара", Color.Blue);
        }
    }
}
