﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Numerics;


namespace lab3
{
    public delegate double RealFunction(double argValue);
    public delegate Complex ComplexFunction(Complex argValue);


    static class FunctionValuesVectors
    {

        static public double[] GetRealFunctionValuesVector(RealFunction func, double period, int N)
        {
            double interval = period / N;
            double[] funcValues = new double[N];

            double x = 0;
            for (int i = 0; i < N; i++)
            {
                funcValues[i] = func(x);
                x += interval;
            }
            return funcValues;
        }

        static public Complex[] GetComplexFunctionValuesVector(ComplexFunction func, double period, int N)
        {
            double interval = period / N;
            Complex[] funcValues = new Complex[N];

            Complex x = 0;
            for (int i = 0; i < N; i++)
            {
                funcValues[i] = func(x);
                x += interval;
            }
            return funcValues;
        }
    }
}
