﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace lab3
{

    static class Walsh
    {

        static public double[] FastWalshTransform(double[] inputValues, int dir)
        {
            if (dir != 1 && dir != -1)
                return new double[] { };

            if (inputValues.Length == 1)
                return inputValues;
            
            int N = inputValues.Length;

            double[] left = new double[N / 2];
            double[] right = new double[N / 2];

            for (int j = 0; j < N / 2; j++)
            {
                left[j] = inputValues[j] + inputValues[j + N / 2];
                right[j] = inputValues[j] - inputValues[j + N / 2];
            }

            double[] b_left = FastWalshTransform(left, dir);
            double[] b_right = FastWalshTransform(right, dir);

            double[] y = new double[N];
            if (dir == 1)  // Прямое преобразование
                for (int j = 0; j < N / 2; j++)
                {
                    y[j] = b_left[j] / 2;
                    y[j + N / 2] = b_right[j] / 2;
                }
            else          // Обратное преобразование
                for (int j = 0; j < N / 2; j++)
                {
                    y[j] = b_left[j];
                    y[j + N / 2] = b_right[j];
                }
            return y;
        }


    }
}
